-----------------------------------------------------------------------------
-- TIProg:	Type Inference for Whole Programs
-- 
-- Part of `Typing Haskell in Haskell', version of September 1, 1999
-- Copyright (c) Mark P Jones and the Oregon Graduate Institute
-- of Science and Technology, 1999
-- 
-- This program is distributed as Free Software under the terms
-- in the file "License" that is included in the distribution
-- of this software, copies of which may be obtained from:
--             http://www.cse.ogi.edu/~mpj/thih/
-- 
-----------------------------------------------------------------------------

module TIProg where
import Subst
import Assump
import TIMonad
import Infer
import TIMain
import Split
import Default

type Program = [BindGroup]

tiProgram :: [Assump] -> Program -> [Assump]
tiProgram as bgs = runTI $
  do (ps, as') <- tiSeq tiBindGroup as bgs
     s         <- getSubst
     let ([], rs) = split [] (apply s ps)
     case topDefaults rs of
       Just s' -> return (apply (s'@@s) as')
       Nothing -> error "top-level ambiguity"

tiBindGroup' as bs = do (ps,as') <- tiBindGroup as bs
                        trim (tv (as'++as))
                        return (ps,as')

tiProgram' :: [Assump] -> Program -> [Assump]
tiProgram' as bgs = runTI $
  do (ps, as') <- tiSeq tiBindGroup' as bgs
     s         <- getSubst
     let ([], rs) = split [] (apply s ps)
     case topDefaults rs of
       Just s' -> return (apply (s'@@s) as')
       Nothing -> error "top-level ambiguity"

-----------------------------------------------------------------------------
